package example
{

    import flash.events.Event;
    import flash.events.EventDispatcher;
    import flash.events.IOErrorEvent;
    import flash.events.SecurityErrorEvent;
    import flash.net.URLLoader;
    import flash.net.URLLoaderDataFormat;
    import flash.net.URLRequest;
    import flash.utils.ByteArray;

    import nq.net.assets.loaders.IAssetLoader;

    public final class ExampleBinaryAssetLoader extends EventDispatcher implements IAssetLoader
    {
        private var _loader:URLLoader;
        private var _data:ByteArray;

        public function ExampleBinaryAssetLoader()
        {

            super();

            _loader = new URLLoader();
            _loader.dataFormat = URLLoaderDataFormat.BINARY;

        }

        private function onError(event:Event):void
        {

            this.close();

            super.dispatchEvent(new Event(Event.CANCEL));

        }

        private function onComplete(event:Event):void
        {

            _data = _loader.data as ByteArray;

            this.close();

            super.dispatchEvent(new Event(Event.COMPLETE));
        }

        /* INTERFACE nq.net.assets.loaders.IAssetLoader */

        public function load(url:String):void
        {

            this.close();
            _data = null;

            _loader.addEventListener(Event.COMPLETE, onComplete);
            _loader.addEventListener(IOErrorEvent.IO_ERROR, onError);
            _loader.addEventListener(SecurityErrorEvent.SECURITY_ERROR, onError);

            _loader.load(new URLRequest(url));

        }

        public function close():void
        {

            _loader.removeEventListener(Event.COMPLETE, onComplete);
            _loader.removeEventListener(IOErrorEvent.IO_ERROR, onError);
            _loader.removeEventListener(SecurityErrorEvent.SECURITY_ERROR, onError);

            try
            {
                _loader.close();
            }
            catch (error:Error)
            {
                // неизвестно, начали мы загрузку или нет
            }

        }

        public function get data():Object
        {
            return _data;
        }
    }

}
