package nq.net.assets.loaders {
    
    import flash.events.IEventDispatcher;

    /**
     * Событие удачной загрузки ресурса
     */
    [Event(name = "complete", type = "flash.events.Event")]

    /**
     * Событие неудачи при загрузке
     */
    [Event(name = "cancel", type = "flash.events.Event")]

    /**
     * Интерфейс для всех загрузчиков ресурсов
     */
    public interface IAssetLoader extends IEventDispatcher {

        /**
         * Начать загрузку ресурса
         *
         * @param   url URL-адрес ресурса для загрузки
         */
        function load(url:String):void;

        /**
         * Остановить загрузку
         */
        function close():void;

        /**
         * Загруженные данные
         */
        function get data():Object;

    }

}