package nq.net.assets.storage {

    /**
     * Интерфейс для хранилища загружаемых ресурсов
     */
    public interface IAssetBundle {

        /**
         * Добавить ассет в пакет ресурсов
         *
         * @param asset Добавляемый ассет
         * @param uri   Уникальное имя ассета в этом пакете
         */
        function addAsset(asset:Object, uri:String):void;

        /**
         * Имеется ли ассет с таким именем в пакете
         *
         * @param uri   Уникальное имя ассета в этом пакете
         */
        function hasAsset(uri:String):Boolean;

        /**
         * Удалить ассет по имени
         *
         * @param uri   Уникальное имя ассета в этом пакете
         */
        function removeAsset(uri:String):void;

        /**
         * Получить ассет по имени
         *
         * @param uri   Уникальное имя ассета в этом пакете
         */
        function getAsset(uri:String):Object;

    }

}
